
/*

Don Dodson
AG Communication Systems

Email: dodsond@agcs.com
Phone: (602)843-3213
Postal address: 4101 W Union Hills Dr #1104
                Glendale, AZ 85308
                USA
*/

#include <time.h>

int OffenseMove[10] = {8, 6, 7, 5, 4, 1, 8, 6, 4, 2};
int DefenseMove[10] = {4, 6, 7, 5, 4, 1, 8, 6, 4, 2};
int Alternate[10]   = {0, 5, 5, 3, 3, 2, 2, 2, 2, 1};
int FirstMove[10]   = {1, 2, 1, 2, 2, 8, 4, 8, 7, 1};
int minMove[9]      = {1, 2, 1, 1, 1, 1, 1, 1, 2};
int otherMove[10][10] = {0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,3,0,0,2,0,0,
                         0,0,0,0,3,0,0,2,0,0,
                         0,0,0,0,3,0,0,2,0,0,
                         3,0,3,3,3,3,3,2,3,3,
                         0,0,0,0,3,0,0,2,0,0,
                         0,0,0,0,3,0,0,2,0,0,
                         2,2,0,2,2,2,2,2,2,0,
                         0,0,0,0,0,0,0,2,0,0,
                         0,0,0,0,0,0,0,0,0,0};


int move1(int score1, int score2, int lastmove);
int move2(int score1, int score2, int lastmove);
int bestMove(int me, int you, int lastmove);
int NextMove(int me, int you, int mylast, int yourlast, int depth);
int pickMoves(int mydist, int yourdist, int yourlast, int *moves);
extern int timeleft(void);

int move1(int score1, int score2, int lastmove) {
    return bestMove(score1, score2, lastmove);
}

int move2(int score1, int score2, int lastmove) {
    return bestMove(score2, score1, lastmove);
}

int bestMove(int me, int you, int lastmove) {
    static int  depth=42, yourlast=0, mylast = 0, turns=0;
    int dist, mydist, yourdist,t;
    int count, moves[3], scores[3], i, max=0;

    turns++;
    if (lastmove) yourlast = lastmove;

    /* First move */
    if (!me) {
        mylast = FirstMove[you];
        return FirstMove[you];
    }

    /* Distance to next hoop */
    mydist = me % 10;
    yourdist = you % 10;
    dist = 10 - mydist;

    /* On a hoop */
    if (me && !mydist) {
        if ((lastmove == mylast) || (9-lastmove == mylast))
            return 0;
        else return mylast;
    }

    /* Winning positions */
    if (!yourdist && ((yourlast == 1) || (yourlast == 8)) &&
          (dist > 3))
        return (mylast = (dist == 4) ? 8 : 1);
    if (!yourdist && (dist & 1) && ((yourlast == 2)
                                 || (yourlast == 7)))
        return (mylast = 2);

    /* Pick moves to try */
    count = pickMoves(mydist,yourdist,yourlast,moves);

    /* If only two moves picked, choose another */
    if ((count < 3) && otherMove[mydist][yourdist] &&
         (otherMove[mydist][yourdist] != moves[0]) &&
         ((count == 1) || (otherMove[mydist][yourdist] != moves[1])) &&
         (otherMove[mydist][yourdist] != lastmove) &&
         (otherMove[mydist][yourdist] != 9-lastmove))
             moves[count++] = otherMove[mydist][yourdist];

    if ((count == 1) && (moves[0] != minMove[lastmove]))
        moves[count++] = minMove[lastmove];

    /* Make recursive calls */
    if (count > 1) {
        for(i = 0; i < count; i++) {
            scores[i] = moves[i] - NextMove(you, me + moves[i],
                        yourlast, moves[i], depth-count);
            if (scores[i] > scores[max]) max = i;
        }
    }
    else i = 1;

    /* How are we doing on time? */
    t = timeleft();
    if (t > 58 - (2 * turns)) depth++;
    if (t < 62 - (4 * turns)) depth--;
    if (t < 62 - (8 * turns)) depth--;
    if (t < 10) depth = 10;

    /* Store selected move */
    if (moves[max]) mylast = moves[max];
    return moves[max];
}

int NextMove(int me, int you, int mylast, int yourlast, int depth) {
    int dist, yourdist,mydist;
    int count, moves[3], scores[3], i, max=0;

    /* Found a winner */
    if (you > 100) {
        dist = (100 - me) * 2;
        if ((dist < 9) && (dist > 0) && (dist != yourlast) &&
            (dist != 9-yourlast))   /* Tie */
             return you - me;
        else return 0;
    }

    /* Recursed far enough */
    if (depth < 1) return 0;

    /* Distance to next hoop */
    mydist = me % 10;
    yourdist = you % 10;
    dist = 10 - mydist;

    /* Look for winning position */
    if ((mydist == 6) && (yourdist == 0) &&
        ((yourlast == 1) || (yourlast == 7))) return 100;

    if (!yourdist && (mydist & 1) && ((yourlast == 2) || (yourlast == 7)))
        return 100;

    /* On a hoop */
    if (me && (mydist == 0)) {
        if ((yourlast == mylast) || (9-yourlast == mylast))
            return 0 - NextMove(you, me, yourlast, mylast, depth-1);
        else return mylast - NextMove(you, me + mylast,
                             yourlast, mylast, depth-1);
    }

    /* Pick moves to try */
    count = pickMoves(mydist, yourdist, yourlast, moves);

    /* Make recursive calls */
    for(i = 0; i < count; i++) {
        scores[i] = moves[i];
        scores[i] -= NextMove(you, me + moves[i], yourlast, moves[i], depth-1);
        if (scores[i] > scores[max]) max = i;
    }

    /* Return best score */
    return scores[max];
}

int pickMoves(int mydist, int yourdist, int yourlast, int *moves) {
    int count=0, offense, defense1, defense2, lastmove,dist,legal=7;

    lastmove = yourdist ? yourlast : 0;
    dist = 10 - mydist;

    /* Pick three good moves */
    offense = OffenseMove[mydist];
    defense1 = yourdist ? DefenseMove[yourdist] : yourlast;
    defense2 = 9-defense1;

    /* Eliminate illegal moves */
    if ((lastmove == offense) || (9-lastmove == offense))
    {   /* These positions have other offense moves */
        if (mydist == 4) offense = 3;
        else if (mydist == 7) offense = 2;
        else legal &= 6;
    }
    if ((lastmove == defense1) || (lastmove == defense2)) {
        if (yourdist == 4) { defense1 = 3; defense2 = 6; }
        else legal &= 1;
    }

    if (legal > 5) {
        if ((offense == defense1) || (defense1 == dist) ||
           ((defense1 > dist) && (defense1 != 2 * dist))) legal &= 5;

        if ((offense == defense2) || (defense2 == dist) ||
           ((defense2 > dist) && (defense2 != 2 * dist))) legal &= 3;
    }

    /* Store selected moves in array */
    if (!legal) moves[count++] = Alternate[mydist];
    if (legal & 1) moves[count++] = offense;
    if (legal & 2) moves[count++] = defense1;
    if (legal & 4) moves[count++] = defense2;

    return count;
}

